/*
	Copyright 1998 Rick
*/

#include	<corlib.h>
#include	<winop.h>
#include	<sys_doslib.h>

#include	"Sesse.c"

#define		PROG		"gv_cred v1.30"
#define		GVIEWWIN	"gview.win"
#define		XSIZE		180
#define		YSIZE		184

typedef struct{
	int x1;
	int y1;
	int x2;
	int y2;
} rect;

extern int	cred( UGraphic*, int );
static void	menumake();
static int	menuchg( WindowID, EventInfo*, int );
static int	EventExec( WindowID, EventInfo* );
static int	GV_cred( UGraphic* );
static int	cpto65( UGraphic*, UGraphic* );

int WindowHeapSize= 1024*0;

UGraphic	ng;
static int	OneTime= FALSE,
		 DataExist= FALSE,
	reduce16= 1,
	/*	0= grayscale, 1= 16colors, 2= 256colors, 3= 65536colors	*/
	ESpread= TRUE,
	red,
	esp,
	menurect[]={ 28,158, 80,178,	/* Ok */
				100,158,152,178,	/* Cancel */
				 30, 20, 84, 32,	/* Espread */
				 30, 34,144, 46,	/* DotUnit */
				 30, 68, 66, 80,	/* 65536 */
				 30, 82, 60, 94,	/* 256 */
				 30, 96,156,108,	/* 16 */
 				 30,110,156,122		/* gray */
};
static char *menu[]= {	" 덷gU",
				" hbgPʍŏ덷",
				" 65536F",
				" 256F",
				" 16F",
				" OCXP[16K"
};

static unsigned short pal16[]= {
	0x0000, 0x5294, 0x0020, 0x003e, 0x0400, 0x07c0, 0x0420, 0x07fe, 
	0x8000, 0xf800, 0x8020, 0xf83e, 0x8400, 0xffc0, 0xad6a, 0xfffe
};



static void
menumake()
{
	if( esp ){
		*menu[0]= '*';
		*menu[1]= ' ';
	}else {
		*menu[0]= ' ';
		*menu[1]= '*';
	}
	switch( red ){
	case 3:
		*menu[2]= '*';
		*menu[3]= ' ';
		*menu[4]= ' ';
		*menu[5]= ' ';
		break;
	case 2:
		*menu[2]= ' ';
		*menu[3]= '*';
		*menu[4]= ' ';
		*menu[5]= ' ';
		break;
	case 1:
		*menu[2]= ' ';
		*menu[3]= ' ';
		*menu[4]= '*';
		*menu[5]= ' ';
		break;
	case 0:
		*menu[2]= ' ';
		*menu[3]= ' ';
		*menu[4]= ' ';
		*menu[5]= '*';
		break;
	}
}

static int
menuchg( wp, info, num )
WindowID	wp;
EventInfo	*info;
int num;
{
	DrawBuf	dbuf[2], *dp= dbuf;
	rect *recttbl= (rect*)menurect + 2;
	int erase, select;
	
	switch( num ){
	case 2:
		esp= TRUE;
		erase= 1;
		select= 0;
		break;
	case 3:
		esp= FALSE;
		erase= 0;
		select= 1;
		break;
	case 4:
	case 5:
	case 6:
	case 7:
		erase= (3 - red ) + 2;
		select= (num - 4) + 2;
		red= (7 - num);
		break;
	default:
		return FALSE;
	}
	*menu[erase]= ' ';
	*menu[select]= '*';
	DrawSetSymbol( dp++, (recttbl + erase)->x1, (recttbl + erase)->y1,
					menu[erase], AttrDefault, 12 );
	DrawSetSymbol( dp++, (recttbl + select)->x1, (recttbl + select)->y1,
					menu[select], AttrDefault, 12 );
	WindowDraw( wp, dbuf, dp - dbuf );
	return	TRUE;
}

static int
EventExec( wp, info )
WindowID wp;
EventInfo *info;
{
	DrawBuf	dbuf[20], *dp= dbuf;
	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp,  EventOpenON|EventRedrawON
			|EventCloseON|EventMouseSwitchON|EventIconifyON
			|EventUserON );
		esp= ESpread;
		red= reduce16;
		menumake();
		WindowRedraw( wp );
		if( !PidSearch( GVIEWWIN, 1 ) ){
			WindowLoadExec( GVIEWWIN, "", NULL, NULL );
		}
		return	TRUE;
	case EventRedraw:
		DrawSetClear( dp++, ColorGray );
		DrawSetSymbol( dp++,  5,  6, "[F]", AttrDefault, 12 );
		DrawSetSymbol( dp++,  5, 54, "[FڕW]", AttrDefault, 12 );
		DrawSetSymbol( dp++, 30, 20, menu[0], AttrDefault, 12 );
		DrawSetSymbol( dp++, 30, 34, menu[1], AttrDefault, 12 );
		DrawSetSymbol( dp++, 30, 68, menu[2], AttrDefault, 12 );
		DrawSetSymbol( dp++, 30, 82, menu[3], AttrDefault, 12 );
		DrawSetSymbol( dp++, 30, 96, menu[4], AttrDefault, 12 );
		DrawSetSymbol( dp++, 30,110, menu[5], AttrDefault, 12 );
		if( DataExist ){
			DrawSetLine( dp++,  28, 158,  80, 178, ShadowUp, OptionShadow );
			DrawSetLine( dp++, 100, 158, 152, 178, ShadowUp, OptionShadow );
			DrawSetSymbol( dp++,  47, 161, "Ok", AttrDefault, 16 );
			DrawSetSymbol( dp++, 103, 161, "Cancel", AttrDefault, 16 );
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		return	TRUE;
	case EventClose:
		WindowClose( wp );
		if( DataExist )	MFREE( (int)ng.palet );
		WindowConnectionClose();
		return	TRUE;
	case EventIconify:
		IconEnt( wp, PROG, AttrDefault|AttrHighLight, 12 );
		return	TRUE;
	case EventMouseSwitch:
		if( info->LeftON ){
			int i, x= info->x, y= info->y;
			rect *recttbl= (rect*)menurect;
			
			for( i= 0; i < 8; i++, recttbl++ ){
				if( recttbl->x1 <= x && recttbl->y1 <= y
						&& recttbl->x2 >= x && recttbl->y2 >= y ){
					switch( i ){
					case 0:	/* Ok */
						if( DataExist ){
							ESpread= esp;
							reduce16= red;
							DrawSetSymbol( dp, 50, 134, "converting!", 9|4, 16 );
							WindowDraw( wp, dbuf, 1 );
							GV_cred( &ng );
						}
					case 1:	/* Cancel */
						if( DataExist ){
							MFREE( (int)ng.palet );
							DataExist= FALSE;
							if( OneTime ){
								WindowClose( wp );
								WindowConnectionClose();
							}else {
								WindowRedraw( wp );
							}
						}
						break;
					case 2:	/* espread */
					case 3:	/* dotunit */
					case 4:	/* 65536 */
					case 5:	/* 256 */
					case 6:	/* 16 */
					case 7:	/* gray */
						menuchg( wp, info, i );
						break;
					}
					break;
				}
			}
		}
		return	TRUE;
	case EventUser:
		if( !DataExist && info->ComData == UserGraphic ){
			if( cpto65( &ng, info->ComBuffer ) ){
				DataExist= TRUE;
				WindowRedraw( wp );
				return	TRUE;
			}
		}
		return	FALSE;
	}
	return	FALSE;
}

static void
memerror()
{
	ConsoleOpen();
	ConsolePrint( "cred : ran of memory\r\n" );
}

static void
MakeNewGWin( ng )
UGraphic	*ng;
{
	EventInfo	info;
	
	info.option= EventUser;
	info.ComBuffer= ng;
	info.ComData= UserGraphic;
	PidSendEvent( GVIEWWIN, &info, TRUE );

}

static int
GV_cred( gp )
UGraphic	*gp;
{
	if( reduce16 == 3 ){
		gp->color= WindowAttrGraphic65536;
		MakeNewGWin( gp );
	}else {
		MouseSetPattern( 1, &SessePattern, 7, 3 );
		MS_SEL( 1 );
		ConsoleOpen();
		ConsolePrint( "Color Reduction System CRED.X version 0.64\r\n" );
		ConsolePrint( "(c) 1995,1996  VSYNC\r\n" );

		gp->color= (reduce16 == 2)? WindowAttrGraphic256 : WindowAttrGraphic16;
		if( cred( gp, ESpread + (reduce16? 0:2) ) >= 0 ){
			MakeNewGWin( gp );
		}else {
			memerror();
		}
		MS_SEL( 0 );
	}
	return	TRUE;
}

static int
cpto65( dgp, sgp )
UGraphic	*dgp;	/* destination */
UGraphic	*sgp;	/* source */
{
	unsigned short	*wtptr, *pal;
	int x, y;

	if( (int)(dgp->palet= MALLOC( sgp->h * sgp->v * 2 + 256 * 2 ) ) < 0 ){
		memerror();
		return FALSE;
	}
	(int)dgp->buf= (int)dgp->palet + 256 * 2;

	wtptr= (void*)dgp->buf;
	if( sgp->color == WindowAttrGraphic65536 ){
		unsigned short	*rdptr= (void*)sgp->buf;

		for( y= 0 ; y< sgp->v ; y++ ){
			for( x= 0 ; x< sgp->h ; x++ ){
				*wtptr++= *rdptr++;
			}
		}
	}else {
		unsigned char	*rdptr= (void*)sgp->buf;
/*		int oddflag= FALSE;
		if( sgp->h & 1 )	oddflag= TRUE;	*/

		if( !(pal= sgp->palet) )	pal= pal16;
		for( y= 0 ; y< sgp->v ; y++ ){
			for( x= 0 ; x< sgp->h ; x++ ){
				*wtptr++= pal[*rdptr++];
			}
/*			if( oddflag )	++rdptr;	*/
		}
	}
	dgp->h= sgp->h;
	dgp->v= sgp->v;

	return	TRUE;
}

void
WindowMain( argc, argv )
int argc;
char	**argv;
{
	int	x= 300, y= 0, pid, pct= -1;
	unsigned int	myinfo= 0;
	char	myname[]= "gv_cred.win";

	argc= AnalyzeArgs( argc, argv, &x, &y, NULL, NULL );
	while( --argc ){
		++argv;
		if( (*argv)[0] == '-' && (*argv)[1] == 'U' ){
			char	table[]= "0123456789ABCDEF",
				*str= *argv + 2;
		    	while( *str ){
				int	i;
		   		for( i= 0; i < 16; i++ ){
					if( *str == table[i] ){
				    		myinfo<<= 4;
						myinfo+= i;
						break;
					}
				}
				if( i == 16 ){
					myinfo= 0;
					break;
				}
				++str;
			}
			break;
		}
	}
	for( pid= 0; pid= PidSearch( myname, pid+1 ); )	pct++;
	if( pct ){
		if( myinfo ){
			PidSendEvent( myname, (EventInfo*)myinfo, TRUE );
		}
		WindowConnectionClose();
	}else {
		WindowID	wp;
		wp= WindowTitleOpen( x, y, XSIZE, YSIZE, NULL, PROG,
						Close|Push|Icon, EventExec );
		if( myinfo ){
			OneTime= TRUE;
			WindowSendEvent( wp, (EventInfo*)myinfo );
		}
	}
}
